package enos.scrabble.domain;

public class Anchor {
  private String letters;
  private int x;
  private int y;
  private Move.Direction direct;

  public Anchor(String letts, int startX, int startY, Move.Direction dir) {
    letters = letts;
    x = startX;
    y = startY;
    direct = dir;
  }

  public int startX() {
    return x;
  }

  public int startY() {
    return y;
  }

  public Move.Direction getDirection() {
    return direct;
  }

  public String getLetters() {
    return letters;
  }

  public int length() {
    return letters.length();
  }

  public String toString() {
    return (direct + " [" + x + "," + y + "]-->" + letters);
  }

  public boolean equals(Object other) {
    if (other == this) {
      return true;
    }
    if (!(other instanceof Anchor)) {
      return false;
    }
    Anchor that = (Anchor)other;
    return (this.letters.equals(that.letters) &&
            this.x == that.x &&
            this.y == that.y &&
            this.direct.equals(that.direct));

  }

}