package enos.scrabble.domain;

import enos.scrabble.datastruct.*;
import java.io.*;
import java.util.*;
import java.net.URL;
public class Dictionary {
  private static Dictionary singleton;
  private HashOfWords words = new HashOfWords();

  public static Dictionary singleton() {
    if (null == singleton)
      singleton = new Dictionary();
    return singleton;
  }

  private Dictionary() {
    try {
      init();
    }
    catch (IOException ex) {
      System.out.println("unable to initialize dictionary");
      ex.printStackTrace();
      System.exit(1);
    }
  }

  public List getCandidates(Word aWord) {
    return words.getMatches(aWord);
  }

  public boolean exists(String str) {
    return words.exists(new Word(str));
  }

  private void init() throws IOException {
    BufferedReader reader = null;
    File file = new File(Game.dictionaryFile);
    if (file.exists()) {
      reader = new BufferedReader(new FileReader(file));
    }else {
      URL url = getClass().getResource("/" + Game.dictionaryFile);
      InputStreamReader isReader = new InputStreamReader(url.openStream());
      reader = new BufferedReader(isReader);
    }
    String line = null;
    while ((line = reader.readLine()) != null) {
//      System.out.println(line);
      words.add(new Word(line.trim()));
    }
    reader.close();
  }
}