package enos.scrabble.domain;

import java.util.*;

public class MoveGroup implements Comparable {
  private Move originalMove;
  private List group;
  private int score = -1;
  private int utility;

  public MoveGroup(Move aMove, List theGroup) {
    originalMove = aMove;
    group = theGroup;
  }

  public int score() {
    if (-1 == score) {
      if (group.size() > 0) {
        score = 0;
        Iterator iter = group.iterator();
        while (iter.hasNext()) {
          Move theMove = (Move) iter.next();
          score += theMove.getScore();
        }
      }
      else {
        score = originalMove.getScore();
      }
    }
    return score;
  }

  public Move originalMove() {
    return originalMove;
  }

  public void setUtility(int u) {
    utility = u;
  }

  public int getUtility() {
    return utility;
  }

  public int compareTo(Object o) {
    if (this == o)
      return 0;
    final MoveGroup that = (MoveGroup) o;
    if (this.score() > that.score()) {
      return -1;
    }
    if (this.score() < that.score()) {
      return 1;
    }
    else
      return 0;
  }

  public boolean equals(Object obj) {
    if (this == obj) return true;
    if (! (obj instanceof MoveGroup)) return false;
    if (this.score() == ((MoveGroup)obj).score()) return true;
    else return false;
  }

}