package enos.scrabble.domain;

public class WordBonusSquare extends Square {
  private int multiplier = 1;

  public WordBonusSquare(int theMultiplier) {
    multiplier = theMultiplier;
  }

  public int wordScore(Move theMove) {
    if (hasBeenUsed()) {
      return super.wordScore(theMove);
    } else {
      return super.wordScore(theMove) * multiplier;
    }
  }

  public String toString() {
    return multiplier + "W";
  }

  public Object clone() {
    WordBonusSquare newSquare = new WordBonusSquare(multiplier);
    if (this.hasBeenUsed())
      newSquare.signalUsed();
    return newSquare;
  }
}